require 'preconditions'
require 'logging_factory'
require 'colorize'
#
# Contains common code used by Thor commands.
# Author: Nayyara Samuel (nayyara.samuel@opower.com)
#
module MultiIndex
  module CommandsCommon
    LOG = Opower::LOGGING_FACTORY.log('MultiIndex')

    def with_exception_handling(&block)
      begin
        yield
      rescue Exception => ex
        LOG.fatal "Something went wrong: \n #{ex.message} \n #{ex.backtrace.join("\n")}\n"
      end
    end

    def print_parameters(options, groups={})
      puts "\nRunning with parameters:".bold

      options.keys.each do |k|
        puts "\t#{k}: #{options[k]}".yellow
      end
    end
  end
end


# To make methods on these modules available
module Preconditions
  def self.included(receiver)
    receiver.send :include, PreconditionMixinMethods
    receiver.send :include, PreconditionModuleClassMethods
  end
end

# To enable bold fonts in the terminal
class String
  def bold;
    "\033[1m#{self}\033[22m"
  end
end